const NS_CHROME_MANIFESTS_FILE_LIST = "ChromeML";

function ArrayEnumerator(array)
{
    this.array = array;
}

ArrayEnumerator.prototype = {
    pos: 0,
  
    hasMoreElements: function ae_hme()
    {
        return this.pos < this.array.length;
    },
    
    getNext: function ae_gn()
    {
        if (this.pos < this.array.length)
            return this.array[this.pos++];
        throw Components.results.NS_ERROR_FAILURE;
    },
    
    QueryInterface: function ae_qi(iid)
    {
        if (iid &&
            (iid.equals(Components.interfaces.nsISimpleEnumerator) ||
             iid.equals(Components.interfaces.nsISupports)))
            return this;

        throw Components.results.NS_ERROR_NO_INTERFACE;
    }
};

function ChromeProvider(manifests)
{
    this._manifests = manifests;
}

ChromeProvider.prototype =
{
    getFile: function cp_gf(prop, persistent)
    {
        throw Cr.NS_ERROR_FAILURE;
    },

    getFiles: function cp_gfs(prop) {
        if (prop == NS_CHROME_MANIFESTS_FILE_LIST)
            return new ArrayEnumerator(this._manifests);

        throw Components.results.NS_ERROR_FAILURE;
    },

    QueryInterface: function cp_qi(iid)
    {
        if (iid &&
            (iid.equals(Ci.nsIDirectoryServiceProvider) ||
             iid.equals(Ci.nsIDirectoryServiceProvider2) ||
             iid.equals(Ci.nsISupports)))
            return this;

        throw Components.results.NS_ERROR_NO_INTERFACE;
    }
};

function registerManifests(manifests)
{
    var dirSvc = getService("@mozilla.org/file/directory_service;1",
                            "nsIDirectoryService");
    var cp = new ChromeProvider(manifests);
    dirSvc.registerProvider(cp);
    return cp;
}

function unregisterManifests(chromeProvider)
{
    var dirSvc = getService("@mozilla.org/file/directory_service;1",
                            "nsIDirectoryService");
    dirSvc.unregisterProvider(chromeProvider);
}